<?php
class ControllerExtensionModuleData8 extends Controller {
	private $error = array();
	
	public function install(){
		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('module_data8', ['module_data8_status' => 1]);
	}

	public function uninstall()
	{
		$this->load->model('setting/setting');
		$this->model_setting_setting->deleteSetting('module_data8');
	}

	public function index() {   
		try {
			$this->load->language('extension/module/data8');

			$this->document->setTitle($this->language->get('heading_title'));
			
			$this->load->model('setting/setting');
					
			if (($this->request->server['REQUEST_METHOD'] == 'POST')) {
				$existingServerApiKey = $this->config->get('data8_apikey');
				$existingClientApiKey = $this->config->get('data8_client_apikey');
				
				if (!array_key_exists('data8_predictiveaddress', $this->request->post))
					$this->request->post['data8_predictiveaddress'] = 'false';
					
				if (!array_key_exists('data8_salaciousnamevalidation', $this->request->post))
					$this->request->post['data8_salaciousnamevalidation'] = 'false';
				
				if (!array_key_exists('data8_inttelephonevalidation', $this->request->post))
					$this->request->post['data8_inttelephonevalidation'] = 'false';

				if (!array_key_exists('data8_telephoneDefaultCountry', $this->request->post))
					$this->request->post['data8_telephoneDefaultCountry'] = '44';

				if(!array_key_exists('data8_useW3WLocation', $this->request->post))
					$this->request->post['data8_useW3WLocation'] = 'false';
				
				$this->model_setting_setting->editSetting('data8', $this->request->post);

				$this->session->data['success'] = $this->language->get('text_success');

				$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', 'SSL'));
				

			}
					
			$data['heading_title'] = $this->language->get('heading_title');
			$data['text_pcllicense'] = $this->language->get('text_pcllicense');
			$data['text_predictiveaddress'] = $this->language->get('text_predictiveaddress');
			$data['label_inttelephonevalidation'] = $this->language->get('label_inttelephonevalidation');
			$data['label_salaciousnamevalidation'] = $this->language->get('label_salaciousnamevalidation');
			$data['text_emailvalidation'] = $this->language->get('text_emailvalidation');
			$data['description_emailvalidation'] = $this->language->get('description_emailvalidation');
			$data['label_useW3WLocation'] = $this->language->get('label_useW3WLocation');
			$data['description_useW3WLocation'] = $this->language->get('description_useW3WLocation');
			$data['button_save'] = $this->language->get('button_save');
			$data['button_cancel'] = $this->language->get('button_cancel');
			$data['text_settings'] = $this->language->get('text_settings');
			$data['text_services'] = $this->language->get('text_services');
			$data['text_edit'] = $this->language->get('text_edit');
			$data['label_emailcustomfields'] = $this->language->get('label_emailcustomfields');
			$data['label_phonecustomfields'] = $this->language->get('label_phonecustomfields');
			$data['label_namecustomfields'] = $this->language->get('label_namecustomfields');

			if (isset($this->error['warning'])) {
				$data['error_warning'] = $this->error['warning'];
			} else {
				$data['error_warning'] = '';
			}

			$data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_home'),
				'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], 'SSL')
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_module'),
				'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', 'SSL')
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/module/data8', 'user_token=' . $this->session->data['user_token'], 'SSL')
			);

			$data['action'] = $this->url->link('extension/module/data8', 'user_token=' . $this->session->data['user_token'], 'SSL');

			$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', 'SSL');

			if (isset($this->request->post['data8_apikey']))
				$data['apikey'] = $this->request->post['data8_apikey'];
			else if ($this->config->get('data8_apikey'))
				$data['apikey'] = $this->config->get('data8_apikey');
			else
				$data['apikey'] = '';

			if (isset($this->request->post['data8_client_apikey']))
				$data['clientapikey'] = $this->request->post['data8_client_apikey'];
			else if ($this->config->get('data8_client_apikey'))
				$data['clientapikey'] = $this->config->get('data8_client_apikey');
			else
				$data['clientapikey'] = '';
			
			if (isset($this->request->post['data8_pcllicense']))
				$data['pcllicense'] = $this->request->post['data8_pcllicense'];
			else if ($this->config->get('data8_pcllicense'))
				$data['pcllicense'] = $this->config->get('data8_pcllicense');
			else
				$data['pcllicense'] = '';
			
			if (isset($this->request->post['data8_predictiveaddress']))
				$data['predictiveaddress'] = $this->request->post['data8_predictiveaddress'];
			else if ($this->config->get('data8_predictiveaddress'))
				$data['predictiveaddress'] = $this->config->get('data8_predictiveaddress');
			else
				$data['predictiveaddress'] = '';
			
			if (isset($this->request->post['data8_salaciousnamevalidation']))
				$data['salaciousnamevalidation'] = $this->request->post['data8_salaciousnamevalidation'];
			else if ($this->config->get('data8_salaciousnamevalidation'))
				$data['salaciousnamevalidation'] = $this->config->get('data8_salaciousnamevalidation');
			else
				$data['salaciousnamevalidation'] = '';

			if (isset($this->request->post['data8_emailvalidation']))
				$data['emailvalidation'] = $this->request->post['data8_emailvalidation'];
			else if ($this->config->get('data8_emailvalidation'))
				$data['emailvalidation'] = $this->config->get('data8_emailvalidation');
			else
				$data['emailvalidation'] = 'MX';

			if (isset($this->request->post['data8_inttelephonevalidation']))
				$data['inttelephonevalidation'] = $this->request->post['data8_inttelephonevalidation'];
			else if ($this->config->get('data8_inttelephonevalidation'))
				$data['inttelephonevalidation'] = $this->config->get('data8_inttelephonevalidation');
			else
				$data['inttelephonevalidation'] = '';
			
			if (isset($this->request->post['data8_telephoneDefaultCountry']))
				$data['defaultCountry'] = $this->request->post['data8_telephoneDefaultCountry'];
			else if ($this->config->get('data8_telephoneDefaultCountry'))
				$data['defaultCountry'] = $this->config->get('data8_telephoneDefaultCountry');
			else
				$data['defaultCountry'] = '44';

			if (isset($this->request->post['data8_useW3WLocation']))
				$data['useW3WLocation'] = $this->request->post['data8_useW3WLocation'];
			else if ($this->config->get('data8_useW3WLocation'))
				$data['useW3WLocation'] = $this->config->get('data8_useW3WLocation');
			else
				$data['useW3WLocation'] = '';
				

			if (isset($this->request->post['data8_emailFields']))
				$data['emailFields'] = $this->request->post['data8_emailFields'];
			else if ($this->config->get('data8_emailFields'))
				$data['emailFields'] = $this->config->get('data8_emailFields');
			else
				$data['emailFields'] = '';

			if (isset($this->request->post['data8_phoneFields']))
				$data['phoneFields'] = $this->request->post['data8_phoneFields'];
			else if ($this->config->get('data8_phoneFields'))
				$data['phoneFields'] = $this->config->get('data8_phoneFields');
			else
				$data['phoneFields'] = '';

			if (isset($this->request->post['data8_nameFields']))
				$data['nameFields'] = $this->request->post['data8_nameFields'];
			else if ($this->config->get('data8_nameFields'))
				$data['nameFields'] = $this->config->get('data8_nameFields');
			else
				$data['nameFields'] = '';

			# ------------------------------------------
			$data['Service_PredictiveAddress'] = true;
			$data['Service_What3Words'] = true;
			$data['Service_AddressCapture_FreeTrial'] = true;
			$data['Service_AddressCapture_FreeTrialThoroughfare'] = true;
			$data['Service_AddressCapture_WebClickFull'] = true;
			$data['Service_AddressCapture_FreeTrial'] = true;
			$data['Service_AddressCapture_WebClickThoroughfare'] = true;
			$data['Service_AddressCapture_WebServerFull'] = true;
			$data['Service_AddressCapture_WebServerThoroughfare'] = true;
			$data['Service_SalaciousNameValidation'] = true;
			$data['Service_EmailValidation'] = true;
			$data['Service_InternationalTelephoneValidation'] = true;
			# ------------------------------------------

		} catch (Exception $e) {
			$data['error_warning'] = $e->getMessage();
		}
	
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/data8', $data));
	}
}
?>